/*
 * @Author: Eward 
 * @Date: 2017-08-17 21:26:07 
 * @Last Modified by: Eward
 * @Last Modified time: 2017-09-28 21:14:54
 */
const webpack = require("webpack");
const paths = require("./paths");
const path = require("path");
const os = require("os");
const ParallelUglifyPlugin = require("webpack-parallel-uglify-plugin");

const publicPath = "/";

// const shouldUseSourceMap = process.env.GENERATE_SOURCEMAP !== "false";
const vendors = require(paths.appConfig).vendors || [];

/** ---- 如果vendor是object,则有可能是用户欲分别拆分包 ---- by Eward */
let entry = {};
if (Array.isArray(vendors)) {
  entry = {
    vendors: vendors
  };
}
if (vendors.toString() === "[object Object]") {
  entry = vendors;
}

module.exports = {
  entry: entry,

  output: {
    filename: "static/js/[name].dll.js",
    path: paths.appBuild,
    library: "[name]_lib",
    publicPath: publicPath
  },
  resolve: {
    modules: ["node_modules", paths.appNodeModules]
  },
  plugins: [
    new webpack.DllPlugin({
      path: path.join(paths.appBuild, "[name]-dll-manifest.json"),
      name: "[name]_lib"
    }),
    new webpack.DefinePlugin({
      "process.env": {
        NODE_ENV: JSON.stringify("production")
      }
    }),
    new ParallelUglifyPlugin({
      cacheDir: ".cache/",
      uglifyJS: {
        compress: {
          warnings: false,
          comparisons: false
        },
        output: {
          comments: false,
          ascii_only: true
        }
      }
    })
  ]
};
